from tkinter import *
#from ray import *
from model3D import *

#■メインプログラム
root= Tk()
root.title("Ray Tracing Mirror Ball and Floor")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
init2D(500,400); origin(250,200)

sc=Scene(Color(0, 0, 255)) #背景色をここで変更してみよう
#            　　  色　　  , 拡散，鏡面, 環境，反射，屈折率
Ac=Attribute(Color(255,0,0), 0.7 , 0.7 , 0.3 , 0.2 , 1.1   )
#ボールの定義
sc.regist(Ball(Point(0,0,80),80),Ac)
#床の定義
Wp= Polygon([Point( 200, 200,-50),Point(-200, 200,-50),
             Point(-200,-200,-50),Point( 200,-200,-50)])
sc.regist(Wall(Wp), Attribute(Color(80,150, 80)))
#視点，照明光ベクトル，視点設定
V0= Point(500,500,500)             #視点
L0= Point(0,400,1000)              #照明光
setview(V0)
#表示開始
k=0;NP=size_xy.x//20
for x in range(size_xy.x):
    if x % NP==0:                             #途中経過表示
        k+=1; root.title("Refraction" + "■"*k)
        root.update()
    for y in range(size_xy.y):
        V  = unit(world(Point(x, y,-dv))-V0)  #視線ベクトル
        VR = Ray(V0,V)                        #視線
        RX = sc.color(VR,L0,6)                #カラー設定
        Cs=RX[0]; L0=RX[1] # RX : [カラー, 次の照明光ベクトル，繰返し回数]
        #print(Cs)
        drawPointXY(canvas, x,y,Cs.toString())

root.title("Ray Tracing Refraction Ball and Floor 完了" )
root.update()
            
